unit Printing;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TfPrinting = class(TForm)
    Label1: TLabel;
    CancelBtn: TBitBtn;
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    Fmax : integer;
  public
    FOnCancel : TNotifyEvent;
    procedure SetMax( max : longint );
    procedure SetProgress( prog : longint );
  end;

implementation

{$R *.DFM}

procedure TfPrinting.SetMax( max : longint );
begin
     FMax := max;
end;

procedure TfPrinting.SetProgress( prog : longint );
begin
     Label1.Caption := 'Printing Page ' + inttostr(prog) + ' of ' + inttostr(fmax);
     Application.ProcessMessages;
end;

procedure TfPrinting.CancelBtnClick(Sender: TObject);
begin
     if Assigned(FOnCancel) then
        FOnCancel(Sender);
end;

procedure TfPrinting.FormShow(Sender: TObject);
var
   i : integer;
begin
     for i := 0 to (Application.ComponentCount-1) do
        begin
        if (Application.Components[i].InheritsFrom(TForm)) and
           (TForm(Application.Components[i]) <> Self) then
           tForm(Application.Components[i]).Enabled := False;
        end;
end;

procedure TfPrinting.FormHide(Sender: TObject);
var
   i : integer;
begin
     for i := 0 to (Application.ComponentCount-1) do
        begin
        if Application.Components[i].InheritsFrom(TForm) then
           tForm(Application.Components[i]).Enabled := True;
        end;
end;

end.
